from datetime import datetime
from typing import Optional

import discord
from cpl_core.database import TableABC

from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.server import Server


class ScheduledEventHistory(HistoryTableABC):
    def __init__(
        self,
        interval: str,
        name: str,
        description: str,
        channel_id: int,
        start_time: datetime,
        end_time: Optional[datetime],
        entity_type: discord.EntityType,
        location: Optional[str],
        server: Optional[Server],
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)
        self._id = id
        self._interval = interval
        self._name = name
        self._description = description
        self._channel_id = channel_id
        self._start_time = start_time
        self._end_time = end_time
        self._entity_type = entity_type
        self._location = location
        self._server = server

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def interval(self) -> str:
        return self._interval

    @interval.setter
    def interval(self, value: str):
        self._interval = value

    @property
    def name(self) -> str:
        return self._name

    @name.setter
    def name(self, value: str):
        self._name = value

    @property
    def description(self) -> str:
        return self._description

    @description.setter
    def description(self, value: str):
        self._description = value

    @property
    def channel_id(self) -> int:
        return self._channel_id

    @channel_id.setter
    def channel_id(self, value: int):
        self._channel_id = value

    @property
    def start_time(self) -> datetime:
        return self._start_time

    @start_time.setter
    def start_time(self, value: datetime):
        self._start_time = value

    @property
    def end_time(self) -> datetime:
        return self._end_time

    @end_time.setter
    def end_time(self, value: datetime):
        self._end_time = value

    @property
    def entity_type(self) -> discord.EntityType:
        return self._entity_type

    @entity_type.setter
    def entity_type(self, value: discord.EntityType):
        self._entity_type = value

    @property
    def location(self) -> str:
        return self._location

    @location.setter
    def location(self, value: str):
        self._location = value

    @property
    def server(self) -> Server:
        return self._server

    @server.setter
    def server(self, value: Server):
        self._server = value
