from cpl_core.database.context import DatabaseContextABC

from bot_data.model.scheduled_event_history import ScheduledEventHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class ScheduledEventHistoryQuery(DataQueryWithHistoryABC):
    def __init__(
        self,
        db: DatabaseContextABC,
    ):
        DataQueryWithHistoryABC.__init__(self, "ScheduledEvent", "ScheduledEventsHistory", ScheduledEventHistory, db)

        self.set_field("id", lambda x, *_: x.id)
        self.set_field("id", lambda x, *_: x.id)
        self.set_field("interval", lambda x, *_: x.interval.value)
        self.set_field("name", lambda x, *_: x.name)
        self.set_field("description", lambda x, *_: x.description)
        self.set_field("channel_id", lambda x, *_: x.channel_id)
        self.set_field("start_time", lambda x, *_: x.start_time)
        self.set_field("end_time", lambda x, *_: x.end_time)
        self.set_field("entity_type", lambda x, *_: x.entity_type)
        self.set_field("location", lambda x, *_: x.location)
        self.set_field("server", lambda x, *_: x.server)
